/* ----------------------------------------------

   EPWING Ͽ̾ե ɽġ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "epwing.h"
#include "kanji.h"

#define ProgramTitle "EPWING Catalogs Viewer Version 1.1"

int main(int argc, char *argv[]) 
{
	FILE * fp;
	EPW_CAT_HEADER epw_header;
	EPW_CAT_BOOKINFO epw_bookinfo;
	int i;
	int booknum;
	char buffer[128];
	char bookname[128];
	char dirname[12];

	/* ޥɥ饤Υå */ 
	if (argc != 2) {
		fprintf( stderr, "%s\n\n", ProgramTitle );
		fprintf( stderr, " usage: catalogviewer <EPWING CATALOGS File Name>\n\n" );
		exit( EXIT_FAILURE );
	}

	if ( ( fp = fopen( argv[1], "rb" ) ) == NULL) {
		fprintf( stderr, "%s\n\n", ProgramTitle );
		fprintf( stderr, "Cannot open \"%s\" \n", argv[1] );
		exit( EXIT_FAILURE );
	}

	/* Read Header */ 
	fread( &epw_header, sizeof( EPW_CAT_HEADER ), 1, fp );
	booknum = epwGetWord( epw_header.books );

	printf( "%s\n\n", ProgramTitle );
	printf( "    Target Filename = %s\n", argv[1] );
	printf( "          Books Num = %u\n", booknum );
	printf( "     EPWING Version = %d\n", epw_header.version );

	for ( i = 0; i < booknum; i++ ) {
		fread( &epw_bookinfo, sizeof( EPW_CAT_BOOKINFO ), 1, fp );

		epwGetStrings( dirname, epw_bookinfo.directory, EPW_CAT_DIRECTORY_LEN );
		epwGetStrings( buffer, epw_bookinfo.bookname, EPW_CAT_BOOKNAME_LEN );
		kanjiconv( bookname, buffer, EPW_CAT_BOOKNAME_LEN );

		printf( "\n" );
		printf( "          Book No. = %d\n", i );

		epwGetBookTypeText( buffer, epw_bookinfo.booktype );
		printf( "         Book Type = %s(%d)\n", buffer, epw_bookinfo.booktype );

		printf( "    EPWING Version = %d\n", epw_bookinfo.version );
		printf( "        Book Title = %s\n", bookname );
		printf( "         Directory = %s\n", dirname );
		printf( " Information Block = %d\n", epwGetWord( epw_bookinfo.infoblock ) ); 
	}

	printf( "\n" );

	fclose( fp );

	return 0;

}
