/* ----------------------------------------------

   EPWINGѶ̴ؿ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */

#include <string.h>

#include "epwing.h"


/* Convert EPWING WORD(2byte,BigEndian) to int */
int epwGetWord( const WORD value )
{
	return ( (int)value[0] << 8 ) + (int)value[1];
}


/* Convert EPWING LONG(4byte,BigEndian) to int */ 
int epwGetLong( const LONG value )
{
	return ( (int)value[0] << 24 ) + ( (int)value[1] << 16 ) + ( (int)value[2] << 8 ) + (int)value[3]; 
}


/* Copy EPWING Strings to char[] */
/* srcǻꤵ줿ݥ󥿤顢ʸdest˥ԡ롣
   EPWINGΥǡ'\0'ǽ餺ĹˤʤäƤʬ⤢뤿ᡢ
   δؿǤϻꤵ줿Ĺ(length)ޤǡޤ'\0'Ĥޤǥԡ
   Ǹ'\0'ղä                                                       */
void epwGetStrings( char *dest, const char *src, const int length )
{
	char *d;
	int i = 0;

	d = dest;
	
	while ( *src && i < length ) {
		*d = *src;
		src++;
		d++;
		i++;
	}
	*d = 0;
}


/* Get EPWING Book Type Strings */
/* char BookTypeText[12] */
void epwGetBookTypeText( char *BookTypeText, BYTE BookType )
{
	switch ( BookType ) {
		case 0x00:
			strcpy( BookTypeText, "켭ŵ" );
			break;

		case 0x10:
			strcpy( BookTypeText, "¼ŵ" );
			break;

		case 0x20:
			strcpy( BookTypeText, "¼ŵ" );
			break;

		case 0x30:
			strcpy( BookTypeText, "±Ѽŵ" );
			break;

		case 0x40:
			strcpy( BookTypeText, "Ѹ켭ŵ" );
			break;
      
		case 0x50:
			strcpy( BookTypeText, "ɴʻŵ" );
			break;
      
		case 0x60:
			strcpy( BookTypeText, "̽ʪ" );
			break;

		case 0x70:
			strcpy( BookTypeText, "켭ŵ" );
			break;

		case 0xF0:
			strcpy( BookTypeText, "ȥ꡼" );
			break;

		default:
			strcpy( BookTypeText, "" );
			break;
	}

}

/* Get EPWING Item ID Strings */
/* ItemIDText[30] */
void epwGetItemIDText( char *ItemIDText, BYTE ItemID )
{

	switch ( ItemID ) {
		case 0x00:
			strcpy( ItemIDText, "ʸ" );
			break;

		case 0x01:
			strcpy( ItemIDText, "˥塼" );
			break;

		case 0x02:
			strcpy( ItemIDText, "ɽ" );
			break;

		case 0x03:
			strcpy( ItemIDText, "︡Ф" );
			break;

		case 0x04:
			strcpy( ItemIDText, "פʸФ" );
			break;

		case 0x05:
			strcpy( ItemIDText, "ɽФ" );
			break;

		case 0x06:
			strcpy( ItemIDText, "פʸФ" );
			break;

		case 0x07:
			strcpy( ItemIDText, "ɽФ" );
			break;

		case 0x08:
			strcpy( ItemIDText, "ױѻФ" );
			break;

		case 0x09:
			strcpy( ItemIDText, "ױѻФ" );
			break;

		case 0x0a:
			strcpy( ItemIDText, "Ф" );
			break;

		case 0x0b:
			strcpy( ItemIDText, "ֹ渫Ф" );
			break;

		case 0x0d:
			strcpy( ItemIDText, "̾︡Ф" );
			break;

		case 0x0f:
			strcpy( ItemIDText, "ǸФ" );
			break;

		case 0x20:
			strcpy( ItemIDText, "˥塼" );
			break;

		case 0x21:
			strcpy( ItemIDText, "ɽ" );
			break;

		case 0x23:
			strcpy( ItemIDText, "ɽ(1ɽ)" );
			break;

		case 0x24:
			strcpy( ItemIDText, "Ф" );
			break;

		case 0x30:
			strcpy( ItemIDText, "ʥǥå" );
			break;

		case 0x40:
			strcpy( ItemIDText, "ѻǥå" );
			break;

		case 0x50:
			strcpy( ItemIDText, "ǥå" );
			break;

		case 0x60:
			strcpy( ItemIDText, "ɽǥå" );
			break;

		case 0x70:
			strcpy( ItemIDText, "פʥǥå" );
			break;

		case 0x71:
			strcpy( ItemIDText, "ɽǥå" );
			break;

		case 0x72:
			strcpy( ItemIDText, "ױѻǥå" );
			break;

		case 0x80:
			strcpy( ItemIDText, "︡ǥå" );
			break;

		case 0x81:
			strcpy( ItemIDText, "ǥå" );
			break;

		case 0x90:
			strcpy( ItemIDText, "פʥǥå" );
			break;

		case 0x91:
			strcpy( ItemIDText, "ɽǥå" );
			break;

		case 0x92:
			strcpy( ItemIDText, "ױѻǥå" );
			break;

		case 0xa0:
			strcpy( ItemIDText, "ֹ楤ǥå" );
			break;

		case 0xa1:
			strcpy( ItemIDText, "̾︡ǥå" );
			break;

		case 0xb0:
			strcpy( ItemIDText, "ڡǥå" );
			break;

		case 0xb1:
			strcpy( ItemIDText, "ǥå" );
			break;

		case 0xd0:
			strcpy( ItemIDText, "Υ" );
			break;

		case 0xd1:
			strcpy( ItemIDText, "ĥΥ" );
			break;

		case 0xd2:
			strcpy( ItemIDText, "顼" );
			break;

		case 0xd8:
			strcpy( ItemIDText, "PCM" );
			break;
      
		case 0xe0:
			strcpy( ItemIDText, "" );
			break;

		case 0xf0:
			strcpy( ItemIDText, "ž" );
			break;

		case 0xf1:
			strcpy( ItemIDText, "(1616ɥå)" );
			break;

		case 0xf2:
			strcpy( ItemIDText, "(816ɥå)" );
			break;

		case 0xf3:
			strcpy( ItemIDText, "(2424ɥå)" );
			break;

		case 0xf4:
			strcpy( ItemIDText, "(1224ɥå)" );
			break;
      
		case 0xf5:
			strcpy( ItemIDText, "(3030ɥå)" );
			break;

		case 0xf6:
			strcpy( ItemIDText, "(1530ɥå)" );
			break;

		case 0xf7:
			strcpy( ItemIDText, "(4848ɥå)" );
			break;

		case 0xf8:
			strcpy( ItemIDText, "(2448ɥå)" );
			break;

		case 0xff:
			strcpy( ItemIDText, "ʣ縡" );
			break;
		
		default:
			if ( ItemID <= 0x2f ) {
				strcpy( ItemIDText, "¾Υƥȥǡ" );
			} else
			if ( 0x70 <= ItemID && ItemID <= 0x7f ) {
				strcpy( ItemIDText, "¾θץǥå" );
			} else
			if ( 0x80 <= ItemID && ItemID <= 0x8f ) {
				strcpy( ItemIDText, "¾ξ︡ǥå" );
			} else
			if ( 0x90 <= ItemID && ItemID <= 0x9f ) {
				strcpy( ItemIDText, "¾ץǥå" );
			} else
			if ( 0xa0 <= ItemID && ItemID <= 0xbf ) {
				strcpy( ItemIDText, "¾Υǥå" );
			} else
			if ( 0xd0 <= ItemID && ItemID <= 0xdf ) {
				strcpy( ItemIDText, "¾Υޥǥǡ" );
			} else {
				strcpy( ItemIDText, "ʥǡ" );
			}
			break;
	}
}
