/* ----------------------------------------------

   EPWING ¤̴ؿ إå

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */

typedef unsigned char BYTE;
typedef unsigned char WORD[2];
typedef unsigned char LONG[4];


/* Ͽ̾ե(CATALOGS) */

/* EPWING CATALOGS Header */
typedef struct {
	WORD books;			/* ҿ */
	BYTE dummy1;
	BYTE version;		/* EPWING Version */
	BYTE dummy2[12];
} EPW_CAT_HEADER;

/* EPWING CATALOGS Book Information */
#define EPW_CAT_BOOKNAME_LEN 80
#define EPW_CAT_DIRECTORY_LEN 8
typedef struct {
	BYTE booktype;		/* Ҥμ */
	BYTE version;		/* EPWING Version */

	BYTE bookname[EPW_CAT_BOOKNAME_LEN];	/* ̾(JIS X0208) */
	BYTE directory[EPW_CAT_DIRECTORY_LEN];	/* ҥǥ쥯ȥ̾(JIS X0208) */
	LONG dirlocation;	/* ҥեǥ쥯ȥ(ά0) */
	WORD infoblock;		/* ҴϿ */
	BYTE gaiji[68];		/* ե */
} EPW_CAT_BOOKINFO;



/* ҥե(HONMON) */

/* EPWING HONMON Header(Ҵ֥å) */
typedef struct {
	WORD itemcount;		/* ҹǿ */
	BYTE booktype;		/* Ҥμ */
	BYTE protecttype;	/* ݸ */
	BYTE indexhandling;	/* ǥåμ谷ˡ */
	/* ҹΤǡǥåͭݤ          */
	/*  00H:ƽҹǤ˵ϿƤ륤ǥåˤ */
	/*  01H:ǥåϰ̣ʤ                     */
	/*  02H:ҹǤ˵ϿƤ륤ǥåͭ   */
	BYTE reserved2[11];	/* ͽΰ裲 */
} EPW_HON_HEADER;

/* EPWING HONMON Item Information(ҹ) */
typedef struct {
	BYTE id;			/* ҹǼ̻ */
	BYTE reserved1;     /* ͽΰ裳 */
	LONG startblock;	/* ǤƬ֥å(1) */
	LONG size;			/* ΰ襵(֥å) */
	BYTE indexvalid;	/* ǥåͭ */
	/*  01H:ǥåϰ̣ʤ  */
	/*  02H:ǥå󤬰̣      */
	BYTE indexinfo[3];	/* ǥå */
	BYTE reserved2[2];	/* ͽΰ裴 */
} EPW_HON_ITEMINFO;


/* EPWING HONMON Header Display Information(Ҵ֥å) */
typedef struct {
	BYTE enable;		/* ̵ͭե饰(ɽˡν;Τ̵ͭ) */
	/*  00H:̵  01H:ͭ */
	BYTE reserved1[3];	/* ͽΰ裵 */
	BYTE isdisplaylist;	/* ɽɽ */
	/*  00H:ľʸɽ  01H:ɽ */
	BYTE bodydisplaytype;	/* ʸɽˡ */
	/* 00H:׹ܤΤɽ  01H:׹ܤƬʸɽ */
	BYTE reserved2[10];	/* ͽΰ裶 */
} EPW_HON_DISPINFO;


#define EPWING_BLOCK_SIZE 2048

/* EPWING HONMON Record Buffer Type */
typedef struct {
	int block;
	unsigned char *pos;
	unsigned char data[EPWING_BLOCK_SIZE];
} EPW_HON_RECORD;

/* EPWING HONMON Body Information */
typedef struct {
	int startblock;
	int lastblock;
	int size;
} EPW_HON_BODYINFO;

#define EPWING_ERROR   0
#define EPWING_SUCCESS 1

/* Convert EPWING WORD to int */ 
int epwGetWord( const WORD value );

/* Convert EPWING LONG to int */ 
int epwGetLong( const LONG value );

/* Copy EPWING Strings to char[] */
void epwGetStrings( char *dest, const char *src, const int length );

/* Get EPWING Book Type Strings */
void epwGetBookTypeText( char *BookTypeText, BYTE BookType );

/* Get EPWING Item ID Strings */
void epwGetItemIDText( char *ItemIDText, BYTE ItemID );