/* ----------------------------------------------

   EPWING ʸХġ Version 1.1
   (ϤȤEUC)
   ᥤ⥸塼

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "epwing.h"
#include "extract_module.h"

#define ProgramTitle "EPWING Examples Extractor ( for EUC code ) Version 1.1"

void DoExtractExamples( FILE *dest );

int main( int argc, char *argv[] ) 
{

	FILE *fp;			/* 񤭽Фե̾ */
	char modname[exextmod_MAX_MODULE_NAME_LEN];

	/* 󥯤줿⥸塼̾μ */
	exextmod_GetModuleName( modname );

	/* ץɽ */
	fprintf( stderr, "\n%s\n", ProgramTitle );
	fprintf( stderr, "  module: %s\n\n", modname );

	/* ޥɥ饤Υå */ 
	if (argc == 2) {
		if ( strcmp( argv[1], "--help" ) == 0 ) {
			fprintf( stderr, "  usage: exextractor <Output File Name>\n\n" );
			exit( EXIT_SUCCESS );
		}

		/* 񤭽Фϻꤵ줿ե */
		if ( ( fp = fopen( argv[1], "w" ) ) == NULL ) {
			fprintf( stderr, "Cannot open '%s'.\n\n", argv[1] );
			exit( EXIT_FAILURE );
		} else {
			fprintf( stderr, "Save to '%s'\n\n", argv[1] );
		}

	} else {
		/* 񤭽Фɸ(stdout) */
		fp = stdout;
	}


	DoExtractExamples( fp );	

	if ( argc == 2 ) {
		fclose( fp );
	}

	return 0;

}


void DoExtractExamples( FILE *dest )
{
	int lines = 0;
	int successlines = 0;

	char *buffer;
	unsigned int buffer_size = exextmod_DEFAULT_MAX_BUFFER_SIZE;
	unsigned int lastsize;

	int i;

	buffer = ( char * )malloc( buffer_size * sizeof( char ) );
	if( buffer == NULL ) {
		fprintf( stderr, "\n" );
		fprintf( stderr, "Memory Allocation Error. Cannot allocate memory for line buffer.\n" );
		exit( EXIT_FAILURE );
	}

	/* ϥ⥸塼 */
	exextmod_Initialize( dest );

	while( fgets( buffer, buffer_size, stdin ) != NULL ) {

		if ( buffer[0] ) {

			while( 1 ) {
				i = strlen( buffer );
				/* ǸβԤǧ */
				if ( buffer[ i - 1 ] == '\n' ) {
					/* Ԥʤ롼פȴ */

					buffer[ i - 1 ] = 0;
					break;

				} else {
					/* ԤǤʤϥХåե­ʤΤǡХåեĥ³ɤ߹ */

					/* Ȥꤢexextmod_DEFAULT_MAX_BUFFER_SIZE bytes䤹 */
					lastsize = buffer_size;
					buffer_size += exextmod_DEFAULT_MAX_BUFFER_SIZE;
					buffer = realloc( buffer, buffer_size );
					#ifdef DEBUG
						fprintf( stderr, "exampleextractor.c:DoExtractExamples() Memory of Line Buffer reallocated.(size=%d)\n", buffer_size );
					#endif
					if( buffer == NULL ) {
						fprintf( stderr, "\n" );
						fprintf( stderr, "Memory Allocation Error. Cannot reallocate memory for line buffer.\n" );
						exit( EXIT_FAILURE );
					}
			
					fgets( &buffer[ lastsize - 1 ] , buffer_size - lastsize, stdin );
				}
			} /* loop */

			/* ºݤβϤϥ⥸塼 */
			if( exextmod_DoParseLine( buffer, buffer_size ) == EPWING_SUCCESS ) {
				successlines++;
			}
		}
		lines++;
	}
	
	exextmod_Terminate();
	free( buffer );

	fprintf( stderr, "\n" );
	fprintf( stderr, " Finished...\n\n" );
	fprintf( stderr, " Extract Information...\n" );
	fprintf( stderr, "       All Lines = %d\n", lines );
	fprintf( stderr, "   Success Lines = %d\n", successlines );
	fprintf( stderr, "\n" );

}
