/* ----------------------------------------------

   EPWING ҥե ʸץġ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "epwing.h"
#include "honmon.h"

#include "kanji.h"

#define ProgramTitle "EPWING HONMON Body Dump tool Version 1.1"

void DoDumpBodyText( void );

int main(int argc, char *argv[]) 
{
	/* ޥɥ饤Υå */ 
	if (argc != 2) {
		fprintf( stderr, "%s\n\n", ProgramTitle );
		fprintf( stderr, " usage: honmondump <EPWING HONMON File Name>\n\n" );
		exit( EXIT_FAILURE );
	}

	if ( honmonOpen( argv[1] ) != EPWING_SUCCESS ) {
		exit( EXIT_FAILURE );
	}

	fprintf( stderr, "%s\n\n", ProgramTitle );
	fprintf( stderr, " Target File = %s\n\n", argv[1] );

	DoDumpBodyText();
	
	honmonClose();
	
	return 0;
}

void DoDumpBodyText( void )
{
	EPW_HON_BODYINFO *bodyinfo;

	unsigned char buffer[5];
	unsigned char jischar[3];
	unsigned char tmp;

	int code;
	unsigned char high;
	unsigned char low;

	unsigned char IsHankakuMode = 0;

	bodyinfo = honmonGetBodyInfo();
	
	fprintf( stderr, " Body Information...\n" );
	fprintf( stderr, "   Start Block = %d\n", bodyinfo->startblock );
	fprintf( stderr, "    Last Block = %d\n", bodyinfo->lastblock );
	fprintf( stderr, "          Size = %d(%d bytes)\n", bodyinfo->size, bodyinfo->size * EPWING_BLOCK_SIZE );
	fprintf( stderr, "\n" );

	honmonMoveBlock( bodyinfo->startblock );

	while ( honmonGetCurrentBlock() <= bodyinfo->lastblock ) {

		code = honmonGetWord();
		high = (unsigned char)( ( code & 0xff00 ) >> 8 );
		low = (unsigned char)( code & 0x00ff );

		/* JIS X4081ʸǡʸϡJIS X0208沽Ƥޤ̾JISɤȸƤФޤˡ    */
		/* ͭʸɤϰϤϡ2121H7426HǤ                                                   */
		/* A121HFE7EHɽ졢ʸѥޤ                           */
		/* ȾѤɽϡȾʸˡȾѳϡסȾѽλפɽ浭һҤϿޤ */
		/* ɽ浭һҤ1FHǻϤޤ2ХȤΥɤǤꡢĴɽԤʤɤޤޤʼबޤ   */
      
		if ( high == 0x1f ) {
			/* EPWING Control Code (0x1f00-0x1fff) */
			
			switch ( low ) {

				case 0x02:		/* ɽϻ Ϣιܥǡκǽ򼨤 */ 
					break;

				case 0x03:		/* ɽλ Ϣιܥǡκǽ򼨤 */
					break;

				case 0x04:      /* Ⱦѻ곫 */
					IsHankakuMode = 1;
					break;

				case 0x05:		/* Ⱦѻ꽪λ */
					IsHankakuMode = 0;
					break;
            
				case 0x09:      /*  */
					honmonMovePos( 1 );
					break;

				case 0x0a:		/* ԥ */
					printf( "\n" );
					break;
					
				case 0x10:		/* ޤ֤ػ  */
					break;

				case 0x11:		/* ޤ֤ػ λ */
					break;

				case 0xe0:		/* Bold Start */
					break;

				case 0xe1:		/* Bold End */
					break;

				case 0x14:		/* Unknown Code(But must skip 2byte...) */
				case 0x1a:
				case 0x1b:
				case 0x1c:
				case 0x1d:
				case 0x1e:
				case 0x1f:		/* emphasis; described in JIS X 4081-1996 */
					honmonMovePos( 1 );
					break;
        
				case 0x39:		/* MPEG Movie */
					honmonMovePos( 22 );
					break;

				case 0x41:		/* ɳ */
					honmonMovePos( 1 );
					break;
              
				case 0x42:		/* ȳ */
					honmonMovePos( 1 );
					break;
        
				case 0x44:		/* Υ */
					honmonMovePos( 5 );
					break;
            
				case 0x45:		/*  or  */
					honmonMovePos( 1 );
					break;
              
				case 0x4a:		/* (Wave) */
					honmonMovePos( 8 );
					break;
            
				case 0x4d:		/* 顼 */
					honmonMovePos( 9 );
					break;
            
				case 0x52:		/* ΥؤλȽλ */
					honmonMovePos( 3 );
					break;

				case 0x53:		/* λ */
					honmonMovePos( 4 );
					break;
              
				case 0x62:		/* Ƚλ */
					honmonMovePos( 3 );
					break;

				case 0x63:		/* ˥塼λ end of an entry of a candidate */
					honmonMovePos( 3 );
					break;
              
				case 0x64:		/* Υλ */
					honmonMovePos( 3 );
					break;
			}
 
		} else if ( 0x2121 <= code && code <= 0x7e7e ) {
			/* JIS Code (0x2121-0x7426) */

			jischar[0] = (unsigned char)( ( code & 0xff00 ) >> 8 );
			jischar[1] = (unsigned char)( code & 0xff );
			jischar[2] = 0x00;

			if ( IsHankakuMode ) {
				tmp = jis2ascii( code );
				if ( tmp == 0x00 ) {
					/* Ⱦѥ⡼ɤˤؤ餺                       */
					/* Ѥˤ¸ߤʤʸȤäƤк */
					kanjiconv( buffer, jischar, strlen( jischar ) );
					printf( "%s", buffer );
				} else {
					/* ASCII ʸ */
					printf( "%c", tmp );
				}
			} else {
				kanjiconv( buffer, jischar, strlen( jischar ) );
				printf( "%s", buffer );
			}
		}

	}

}
