/* ----------------------------------------------

   EPWING ҥե Ҵ֥åɽġ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "epwing.h"
#include "honmon.h"

#define ProgramTitle "EPWING HONMON Information Block Viewer Version 1.1"

int main(int argc, char *argv[]) 
{

	EPW_HON_HEADER *header;
	EPW_HON_ITEMINFO *iteminfo;

	int itemcount;
	int i;

	char buffer[30];

	/* ޥɥ饤Υå */ 
	if (argc != 2) {
		fprintf( stderr, "%s\n\n", ProgramTitle );
		fprintf( stderr, " usage: honmoninfoviewer <EPWING HONMON File Name>\n\n" );
		exit( EXIT_FAILURE );
	}

	if ( honmonOpen( argv[1] ) != EPWING_SUCCESS ) {
		exit( EXIT_FAILURE );
	}

	header = honmonGetHeader();
	iteminfo = honmonGetItemInfo();
	itemcount = epwGetWord( header->itemcount );

	printf( "%s\n\n", ProgramTitle );

	printf( "  Target File = %s\n", argv[1] );
	printf( "        Items = %d\n", itemcount );

	epwGetBookTypeText( buffer, header->booktype );
	printf( "    Book Type = %s(%d)\n", buffer, header->booktype );
	
	printf( " Protect Type = %d\n", header->protecttype );
	printf( "\n" );

	printf( "   ID | Start Block No. | Block Size | Description\n" );
	printf( "----------------------------------------------------------------------\n" );

	for ( i = 0; i < itemcount; i++ ) {
		epwGetItemIDText( buffer, iteminfo[i].id );
		printf( " 0x%02X | %15d | %10d | %s\n",
				iteminfo[i].id,
				epwGetLong( iteminfo[i].startblock ),
				epwGetLong( iteminfo[i].size ),
				buffer );
	}	

	printf( "\n" );

	honmonClose();

	return 0;

}





