/* ----------------------------------------------

   EPWING ʸХġ

   ϡ񤭽Ф⥸塼
   for ӥͥѸʸŵ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <string.h>
#include <stdlib.h>

#include "../extract_module.h"
#include "../epwing.h"
#include "../kanji.h"
#include "../strfunc.h"


#define ModuleName "ӥͥѸʸŵ"
#define SourceFile "bzengbunrei.c"

FILE *fp;


int exextmod_Initialize( FILE *dest )
{

	fp = dest;

	return EPWING_SUCCESS;

}

int exextmod_Terminate( void )
{

	return EPWING_SUCCESS;

}


/* char modulename[exextmod_MAX_MODULE_NAME_LEN] */
void exextmod_GetModuleName( char *modulename )
{
	sprintf( modulename, "%s(%s)", ModuleName, SourceFile );
}

/* char LineData[buffersize] */
/* Return Value) EPWING_SUCCESS -> Success(Expample)  */
/*               EPWING_ERROR   -> Error(Other)       */
int exextmod_DoParseLine( char *LineData, const unsigned int buffersize )
{
	/* ʸ */

	/*֤ˤäƶϤ*/
	/*Ҥϡξʤ֤äƤꡤʤܤǤˤĤƤϡ˵ҤȶϤ¸Ǥ */
	/*We have extensive sales networks for these lines of goods and shall always be ready to cooperate with you in the marketing of your products in Japan. */
	/* () */
	/*ʤȼξܤ*/
	/*ҤϤȤ˵ʤ˶̣äƤꡤʤˤĤƤΡäȾܤȤȤˤΤ餻¸ޤ */
	/*We are particularly interested in your products, and would like to have more detailed information on all of your commodities, together with trade terms. */

	/*  */
	/* 1. ""ǻϤޤԤõ */
	/* 2. ΣԤʸȤʤ롣 */
	/*    μ˶ԤʤʸȤưʤ */

	/* ­ */
	/* ʸιƬˤ""(ѥڡ)äƤΤǤ */

	static const unsigned char exWideBracket[] = "";
	static const unsigned char exWideSpace[] = "";

	static int exStartFlag = 0;

	static unsigned char *japanese;
	static unsigned char *english;

	unsigned char *p;

	p = (unsigned char*)LineData;


	switch( exStartFlag ) {

		case 0: /* ""򸡺 */
			
			if ( strncmp( p, exWideBracket, strlen( exWideBracket ) ) == 0 ) {
				/* ""Ĥä */
				exStartFlag = 1;

				return EPWING_SUCCESS;
			} else {
				return EPWING_ERROR;
			}


		case 1:  /* ǽιԤ򸡺 */

			/* ǽܸʸ */

			if ( strncmp( p, exWideSpace, strlen( exWideSpace ) ) == 0 ) {
				/* ѥڡ */
				p += 2;
			}
			
			exStartFlag = 2;
			japanese = (char *)malloc( strlen( p ) + 1 );
			strcpy( japanese, p );

			return EPWING_SUCCESS;


		case 2: /*  */

			if ( strncmp( p, exWideSpace, strlen( exWideSpace ) ) == 0 ) {
				/* ѥڡ */
				p += 2;
			}

			if ( KanjiSearch2( p, 1 ) ) {
				free( japanese );
				#ifdef DEBUG
					fprintf( stderr, "%s:exectmod_DoParseLine() case2: 2byte char found...[%s]\n", SourceFile, p );
				#endif
				exStartFlag = 0;
				return EPWING_ERROR;
			}

			exStartFlag = 3;
			english = (char *)malloc( strlen( p ) + 1 );
			strcpy( english, p );

			return EPWING_SUCCESS;


		case 3: /* Ԥǧ */

			if ( *p != 0x00 ) {
				/* ԤǤʤΤǡʸ̵뤹 */
				free( english );
				free( japanese );
				exStartFlag = 0;
				return EPWING_ERROR;
			}

			exStartFlag = 0;
			break;


		default:

			#ifdef DEBUG
				fprintf( stderr, "%s:exectmod_DoParseLine() Unknown code...\n", SourceFile );
			#endif

			exStartFlag = 0;
			return EPWING_ERROR;

	}

	ltrim( japanese );
	ltrim( english );

	if( ! ( strlen( japanese ) && strlen( english ) ) ) {
		/* ɤ餫ʸĹ */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Length of Strings is 0...\n", SourceFile );
		#endif

		free( japanese );
		free( english );

		return EPWING_ERROR;
	}

	fprintf( fp, "%s\n", japanese );
	fprintf( fp, "%s\n", english );

	free( japanese );
	free( english );

	return EPWING_SUCCESS;

}

