/* ----------------------------------------------

   EPWING ʸХġ

   ϡ񤭽Ф⥸塼
   for  Ա³缭ŵ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <string.h>
#include <stdlib.h>

#include "../extract_module.h"
#include "../epwing.h"
#include "../kanji.h"
#include "../strfunc.h"


#define ModuleName " Ա³缭ŵ"
#define SourceFile "collocations.c"

FILE *fp;

int exextmod_Initialize( FILE *dest )
{

	fp = dest;

	return EPWING_SUCCESS;

}

int exextmod_Terminate( void )
{

	return EPWING_SUCCESS;

}


/* char modulename[exextmod_MAX_MODULE_NAME_LEN] */
void exextmod_GetModuleName( char *modulename )
{
	sprintf( modulename, "%s(%s)", ModuleName, SourceFile );
}

/* char LineData[buffersize] */
/* Return Value) EPWING_SUCCESS -> Success(Expample)  */
/*               EPWING_ERROR   -> Error(Other)       */
int exextmod_DoParseLine( char *LineData, const unsigned int buffersize )
{
	/* ʸ */
	/* use an abacus to calculate a sum ۤ׻ΤˤФѤ. */
	/* The wind was right [straight] abaft. ä. */
	/* We abbreviate dozen as dz. dozen  dz ά */
	/* the fall [spring, summer] semester [, ]γش. */
	/* an all-round [Ƥޤ all-around] sportsman ݡĤʤʤǤǤ */

	/* ʬΥ */
	/* 1.   " "(0x20)Ƕڤ줿ϰϤǣİʾϢ³2byteʸ򸫤Ĥ硢 */
	/*      ľ" "ʸܸʸζڤ򤹤롣                          */
	/* 2.   ". "(0x2e,0x20)򸫤Ĥ顢ڤȤ롣              */
	/* 2-2. ޤ ".\" "(0x2e,0x22,0x20)Ʊˤ                  */
	/*      ľˣİʾASCIIʸΥ֥åȤ  */
	/*      ʸ³ΤȤ롣                                         */
	/* 3.   []ǰϤޤ줿̵뤹롣                                 */
	/*      ( " "ڤʸȤưʤʤ )                          */
	/* ȣΤɤ餫ǽλ롣                */

	/* ʸʸ */
	static const unsigned char exStartChar1[] = "";    /* EUC: 0xa2a1, SJIS: 0x819f */

	unsigned char *japanese;
	unsigned char *english;

	unsigned char *p, *s, *t;

	int cnt;
	int isinbracket = 0; /* ѥ */

	/* ʸ */
	if ( strncmp( LineData, exStartChar1, strlen( exStartChar1 ) ) == 0 ) {
		p = LineData + strlen( exStartChar1 );
	} else {
		return EPWING_ERROR;
	}

	s = p;

	/*  " "(0x20)򸡺ơȽ򤹤 */
	while ( *p ) {
		if ( *p == '[' ) {
			isinbracket++;
		}
		if ( *p == ']' ) {
			isinbracket--;
		}

		if ( ( *p == 0x20 ) && ( isinbracket <= 0 ) ) {
			/* ˣ */
			if ( SeqKanjiSearch( (char *)( p + 1 ), 2 ) ) {
				#ifdef DEBUG
					fprintf( stderr, "Line Type 1\n" );
				#endif
				break;
			}
			/* ˣ */
			if ( *( p - 1 ) == '.' ) {
				#ifdef DEBUG
					fprintf( stderr, "Line Type 2\n" );
				#endif
				break;
			}
			/* ˣ- */
			if ( *( p - 1 ) == 0x22 && *( p - 2 ) == 0x2e ) {
				/* 㳰 */
				t = p + 1;
				cnt = 0;
				while( *t ) {
					if ( IsEucKanji( *t ) ) {
						cnt = 0;
						break;
					} else {
						if ( *t == 0x20 ) {
							cnt++;
						}
						if ( cnt >= 4 ) {
							break;
						}
						t++;
					}
				}

				if ( cnt < 4 ) {
					/* 㳰ƤϤޤʤ */
					#ifdef DEBUG
						fprintf( stderr, "Line Type 2-2(Break)\n" );
					#endif
					break;
				}

				#ifdef DEBUG
					fprintf( stderr, "Line Type 2-2(Continue):" );
				#endif

			}

		}

		/* EUCǤδ2byte */
		if ( IsEucKanji( *p ) ) {
			p += 2;
		} else {
			p++;
		}
	}

	if ( ! *p ) {
		/* ڤ꤬Ĥʤä */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Can't find separater...\n", SourceFile );
		#endif
		return EPWING_ERROR;
	}

	*p = 0;

	/* Ѹ */
	english = malloc( strlen( s ) * sizeof( char ) + 1 );
	strcpy( english, s );

	p++;

	/* ܸ */
	japanese = malloc( strlen( p ) * sizeof( char ) + 1 );
	strcpy( japanese, p );

	if( ! ( strlen( japanese ) && strlen( english ) ) ) {
		/* ɤ餫ʸĹ */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Length of Strings is 0...\n", SourceFile );
		#endif

		free( japanese );
		free( english );

		return EPWING_ERROR;
	}

	fprintf( fp, "%s\n", japanese );
	fprintf( fp, "%s\n", english );

	free( japanese );
	free( english );

	return EPWING_SUCCESS;

}
