/* ----------------------------------------------

   EPWING ʸХġ

   ϡ񤭽Ф⥸塼
   for ѱѸϥɥ֥å

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <string.h>
#include <stdlib.h>

#include "../extract_module.h"
#include "../epwing.h"
#include "../kanji.h"
#include "../strfunc.h"


#define ModuleName "ѱѸϥɥ֥å"
#define SourceFile "jituyoehb.c"

FILE *fp;

/* ʸȾʸѴ롣 */
/* EUC                          */
void wide2narrow( unsigned char *dest, const unsigned char *src );


int exextmod_Initialize( FILE *dest )
{

	fp = dest;

	return EPWING_SUCCESS;

}

int exextmod_Terminate( void )
{

	return EPWING_SUCCESS;

}


/* char modulename[exextmod_MAX_MODULE_NAME_LEN] */
void exextmod_GetModuleName( char *modulename )
{
	sprintf( modulename, "%s(%s)", ModuleName, SourceFile );
}

/* char LineData[buffersize] */
/* Return Value) EPWING_SUCCESS -> Success(Expample)  */
/*               EPWING_ERROR   -> Error(Other)       */
int exextmod_DoParseLine( char *LineData, const unsigned int buffersize )
{
	/* ʸ */

	/*  1                                                                     */
	/* The insured* may abandon the vessel or goods to the underwriter.         */
	/* ݸԤޤϲʪ򳤾ݸȼԤ˰դ뤳ȤǤ롣           */
	
	/* 185                                                                    */
	/* The seller is not responsible for non-delivery of goods at destination.  */
	/* ϻŸϤˤʪ԰Ϥˤդʤ                     */

	/* 24                                                                     */
	/* We offered 10 but our competitors bid* against us.                 */
	/* 10ݥɤȿФ⤤դͤ򤷤                 */
	/* *ΰ̣bidϸ߷ʬȤƱ                     */
	/* They bid 19 for the goods.                                         */
	/* ʤ19ɥλؤͤ򤷤                                     */


	/*  */
	/* 1. "n"õ(nȾorѡ磳塢EUCǺ5bytes)  */
	/* 2. ΣԤʸȤʤ롣ʲ㳰ͤ롣       */

	/* 㳰 */
	/* 1. ""򸫤Ĥ硢""ʤɤ⸡롣             */
	/* 2. ǽ1byte򸫤ƣܤʸܸʸȽ̤롣    */
	/* 3. Ƭ"*",""ϥȰ(ԤƱ)       */
	/* 4. "n"ˤؤ餺ԤǤʤڤΤƤ            */

	static const unsigned char exWidePeriod[] = "";
	static const unsigned char exWideBracket[] = "";
	static const unsigned char exWideSpace[] = "";

	static int exStartFlag = 0;
	static int exIsFirstEng = 0;

	static unsigned char *japanese;
	static unsigned char *english;

	unsigned char *p;

	unsigned char buffer[5];

	unsigned int length;

	length = strlen( LineData );
	p = (unsigned char*)LineData;

	if ( ( *p == 0x00 ) || ( *p == '*' ) || ( strncmp( p, exWideSpace, strlen( exWideSpace ) ) == 0 ) ) {
		/*  */
		switch ( exStartFlag ) {
			case 1:
				exStartFlag = 0;
				break;

			case 2:
			case 10:
				if ( exIsFirstEng ) {
					free( english );
				} else {
					free( japanese );
				}

				exStartFlag = 0;
				break;

			case 11:
				break;

			default:
				break;

		}			
		return EPWING_ERROR;
	}

	if ( length <= 5 ) {
		/* "n"ɤĴ٤롣 */
		if ( strncmp( (char *)(p+length-2), exWidePeriod, strlen( exWidePeriod ) ) == 0 ) {
			/* Ǹ"" */
			*(p+length-2) = 0;
			wide2narrow( buffer, p );
			if ( atoi( buffer ) >= 1 ) {
				/* ʸ */
				exStartFlag = 1;
				return EPWING_SUCCESS;
			}
		}
		
		return EPWING_ERROR;
	}


	switch( exStartFlag ) {

		case 0: /* "n"򸡺 */

			/* λ exStartFlag  0 ȤȤϡ"n"ޤõƤ롣 */
			
			return EPWING_ERROR;


		case 1:  /* ǽιԤ򸡺 */
		case 11:

			if ( IsEucKanji( *p ) ) {
				/* ǽܸʸ""ɤ */
				if( strncmp( (char *)( p + 2 ), exWideBracket, strlen( exWideBracket ) ) == 0 ) {
					/* ʣʸ⡼ */
					exStartFlag = 10;
					exIsFirstEng = 1;
					english = (char *)malloc( strlen( (char *)( p + 4 ) ) +1 );
					strcpy( english, (char *)( p + 4 ) );
					return EPWING_SUCCESS;
				}
				
				if ( exStartFlag == 11 ) {
					/* ʣʸ⡼ɤˤ⤫餺""ǻϤޤʤ */
					exStartFlag = 0;

					#ifdef DEBUG
						fprintf( stderr, "%s:exectmod_DoParseLine() case11: Not start '?)' [%s]\n", SourceFile, LineData );
					#endif

					return EPWING_ERROR;
				}

				/* ܸ */
				exIsFirstEng = 0;
				exStartFlag = 2;
				japanese = (char *)malloc( strlen( p ) + 1 );
				strcpy( japanese, p );

				return EPWING_SUCCESS;

			}

			/* ʸ */
			exIsFirstEng = 1;
			exStartFlag = 2;
			english = (char *)malloc( strlen( p ) + 1 );
			strcpy( english, p );

			return EPWING_SUCCESS;


		case 2: /*  */

			if ( exIsFirstEng ) {

				if ( KanjiSearch2( p, 1 ) == 0 ) {
					/* ܸ줬ϤʤΤ˱Ѹ */
					free( english );
					exStartFlag = 0;

					#ifdef DEBUG
						fprintf( stderr, "%s:exectmod_DoParseLine() case2: Not Japanese.\n", SourceFile );
					#endif

					return EPWING_ERROR;
				}

				japanese = (char *)malloc( strlen( p ) + 1 );
				strcpy( japanese, p );

			} else {

				if ( IsEucKanji ( *p ) ) {
					/* ʸϤʤΤܸ */
					free( japanese );
					exStartFlag = 0;

					#ifdef DEBUG
						fprintf( stderr, "%s:exectmod_DoParseLine() case2: Not English.\n", SourceFile );
					#endif

					return EPWING_ERROR;
				}

				english = (char *)malloc( strlen( p ) + 1 );
				strcpy( english, p );

			}
			exStartFlag = 0;
			
			break;


		case 10: /* ʣʸ⡼ */

			/* ܤܸʸȲ */
			japanese = (char *)malloc( strlen( p ) + 1 );
			strcpy( japanese, p );

			exStartFlag = 11;

			break;


		default:

			#ifdef DEBUG
				fprintf( stderr, "%s:exectmod_DoParseLine() Unknown code...\n", SourceFile );
			#endif

			exStartFlag = 0;
			return EPWING_ERROR;

	}


	if( ! ( strlen( japanese ) && strlen( english ) ) ) {
		/* ɤ餫ʸĹ */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Length of Strings is 0...\n", SourceFile );
		#endif

		free( japanese );
		free( english );

		return EPWING_ERROR;
	}

	fprintf( fp, "%s\n", japanese );
	fprintf( fp, "%s\n", english );

	free( japanese );
	free( english );

	return EPWING_SUCCESS;

}

/* ʸȾʸѴ롣            */
/* EUC                       */
/* EUC->JISѴjis2ascii()ƤӽФ */
void wide2narrow( unsigned char *dest, const unsigned char *src )
{
	unsigned char *p;
	unsigned int jiscode;

	p = src;

	while( *p ) {
		if ( IsEucKanji( *p ) ) {
			jiscode = ( *p - 0x80 ) * 0x100 + ( *(p+1) - 0x80 );
			*dest = jis2ascii( jiscode );
			if ( *dest == 0x00 ) {
				*dest = 0x20;
			}
			p += 2;
		} else {
			*dest = *p;
			p++;
		}
		dest++;
	}
	*dest = 0x00;
}
