/* ----------------------------------------------

   EPWING ʸХġ

   ϡ񤭽Ф⥸塼
   for  ±缭ŵ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <string.h>
#include <stdlib.h>

#include "../extract_module.h"
#include "../epwing.h"
#include "../kanji.h"
#include "../strfunc.h"


#define ModuleName " ±缭ŵ"
#define SourceFile "newjedic.c"

FILE *fp;

int newjedic_KanjiSearch( const char *target, const int count );

int exextmod_Initialize( FILE *dest )
{

	fp = dest;

	return EPWING_SUCCESS;

}

int exextmod_Terminate( void )
{

	return EPWING_SUCCESS;

}


/* char modulename[exextmod_MAX_MODULE_NAME_LEN] */
void exextmod_GetModuleName( char *modulename )
{
	sprintf( modulename, "%s(%s)", ModuleName, SourceFile );
}

/* char LineData[buffersize] */
/* Return Value) EPWING_SUCCESS -> Success(Expample)  */
/*               EPWING_ERROR   -> Error(Other)       */
int exextmod_DoParseLine( char *LineData, const unsigned int buffersize )
{
	/* ʸ */
	/* ˽⤬ kick and struggle. */
	/* ٥åǳҤعԤ go to Kamakura with one's sweetheart [girl friend, date]. */
	/* Фش, ʤ. Don't come near. You may get hurt. */

	/* ʬΥ */
	/* Ϥ˸줿" "(0x20)ڤˤ롣 */

	/* 㳰 */
	/* 0x20줿2byteʸ֥åäϡΥ֥åθ0x20ڤˤ */
	/* ޤ2byteʸ̵ǰΤ⤦֥åƤߤ */
	/* ,դ2byteʸʤ */

	/* ʸʸ */
	static const unsigned char exStartChar1[] = "";    /* EUC: 0xa2f9, SJIS: 0x817f */

	unsigned char *japanese;
	unsigned char *english;

	unsigned char *p, *s, *t;

	/* ʸ */
	if ( strncmp( LineData, exStartChar1, strlen( exStartChar1 ) ) == 0 ) {
		p = LineData + strlen( exStartChar1 );
	} else {
		return EPWING_ERROR;
	}

	s = p;

	/*  " "(0x20)򸡺ơȽ򤹤 */
	while ( *p ) {

		if ( *p == 0x20 ) {
			/* 㳰 */
			if ( newjedic_KanjiSearch( (char *)( p + 1 ), 1 ) == 0 ) {
				t = p + 1;
				while ( ( *t != 0x20 ) && ( *t != 0x00 ) ) {
					t++;
				}
				if ( *t == 0x20 ) {
					if ( newjedic_KanjiSearch( (char *)( t + 1 ), 1 ) == 0 ) {
						break;
					}
				} else {
					break;
				}
			}
		}

		/* EUCǤδ2byte */
		if ( IsEucKanji( *p ) ) {
			p += 2;
		} else {
			p++;
		}
	}

	if ( ! *p ) {
		/* ڤ꤬Ĥʤä */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Can't find separater...[%s]\n", SourceFile, LineData );
		#endif
		return EPWING_ERROR;
	}

	*p = 0;

	/* ܸ */
	japanese = malloc( strlen( s ) * sizeof( char ) + 1 );
	strcpy( japanese, s );

	p++;

	/* Ѹ */
	english = malloc( strlen( p ) * sizeof( char ) + 1 );
	strcpy( english, p );
	
	if( ! ( strlen( japanese ) && strlen( english ) ) ) {
		/* ɤ餫ʸĹ */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Length of Strings is 0...\n", SourceFile );
		#endif

		free( japanese );
		free( english );

		return EPWING_ERROR;
	}

	fprintf( fp, "%s\n", japanese );
	fprintf( fp, "%s\n", english );

	free( japanese );
	free( english );

	return EPWING_SUCCESS;

}


/* target[]ʸ countİʾ2byteʸ¸ߤ뤫ɤĴ롣 */
/* 0x20(" ")򸫤ĤȡĴλ                     */
/* 㳰Ȥơ,դ2byteʸʤ                                  */
/* Return Value)                       */
/*   1: Found                          */
/*   0: Not Found                      */
int newjedic_KanjiSearch( const char *target, const int count )
{
	/*   */
	static const unsigned char exBracket1[] = "";
	static const unsigned char exBracket2[] = "";

	char *p;
	int flag = 0;

	p = target;

	/* Ϣ³2byteʸθ */
	while ( ( *p != 0x20 ) && ( *p != 0x00 ) ) {
		if( IsEucKanji( *p ) ) {
			/* 2byte char */

			if ( strncmp( p, exBracket1, strlen( exBracket1 ) ) != 0 &&
				 strncmp( p, exBracket2, strlen( exBracket2 ) ) != 0    ) {
				/*  հʳ */

				flag++;
			}

			p += 2;
		} else {
			/* 1byte char */
			p++;
		}

		if ( flag >= count ) {
			/* countİʾ2byteʸä */
			return 1;
		}
	}	

	/* flag >= count ʤΤ 0 ֤ */
	return 0;
}
