/* ----------------------------------------------

   EPWING ʸХġ

   ϡ񤭽Ф⥸塼
   for Σţ׺ƣ±缭ŵ

   Copyright (c) 2001-2002 Keichiro Katayama
                    keichiro@ike.tottori-u.ac.jp

   ---------------------------------------------- */  

#include <string.h>
#include <stdlib.h>

#include "../extract_module.h"
#include "../epwing.h"
#include "../kanji.h"
#include "../strfunc.h"


#define ModuleName "Σţ׺ƣ±缭ŵ"
#define SourceFile "saitowaei.c"

FILE *fp;

int exextmod_Initialize( FILE *dest )
{

	fp = dest;

	return EPWING_SUCCESS;

}

int exextmod_Terminate( void )
{

	return EPWING_SUCCESS;

}


/* char modulename[exextmod_MAX_MODULE_NAME_LEN] */
void exextmod_GetModuleName( char *modulename )
{
	sprintf( modulename, "%s(%s)", ModuleName, SourceFile );
}

/* char LineData[buffersize] */
/* Return Value) EPWING_SUCCESS -> Success(Expample)  */
/*               EPWING_ERROR   -> Error(Other)       */
int exextmod_DoParseLine( char *LineData, const unsigned int buffersize )
{
	/* ʸ */
	/* ϰʤꡡGod is love. */
	/* ƱࡡLike draws to like. */

	/* ʸʸ */
	static const unsigned char exStartChar1[] = "";    /* EUC: 0xa2a1, SJIS: 0x819f */
	static const unsigned char exStartChar2[] = "";    /* EUC: 0xa1fe, SJIS: 0x819e */

	/* ܸʸʸڤʸ */
	static const unsigned char exSeparateChar[] = "";  /* EUC: 0xa1a1, SJIS: 0x8140 */

	unsigned char *japanese;
	unsigned char *english;

	unsigned char *p, *s;

	/* ʸ */
	if ( strncmp( LineData, exStartChar1, strlen( exStartChar1 ) ) == 0 ) {
		p = LineData + strlen( exStartChar1 );
	} else 
	if ( strncmp( LineData, exStartChar2, strlen( exStartChar2 ) ) == 0 ) {
		p = LineData + strlen( exStartChar2 );
	} else {
		return EPWING_ERROR;
	}

	s = p;

	/* ܸ줬ʬޤǸ */
	while ( *p ) {
		if ( strncmp( p, exSeparateChar, strlen( exSeparateChar ) ) == 0 ) {
			/* ڤʸ */
			break;
		}

		/* EUCǤδ2byte */
		if ( IsEucKanji( *p ) ) {
			p += 2;
		} else {
			p++;
		}
	}

	if ( ! *p ) {
		/* ڤ꤬Ĥʤä */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Can't find separater...\n", SourceFile );
		#endif
		return EPWING_ERROR;
	}

	*p = 0;
	*(p+1) = 0;

	/* ܸ */
	japanese = malloc( strlen( s ) * sizeof( char ) + 1 );
	strcpy( japanese, s );

	p += 2;

	/* Ϣ³ڤʸк */
	while ( strncmp( p, exSeparateChar, strlen( exSeparateChar ) ) == 0 ) {
		p += 2;
	}
	
	/* Ѹ */
	english = malloc( strlen( p ) * sizeof( char ) + 1 );
	strcpy( english, p );
	
	/* Ƭζк() */
	ltrim( english );

	/* Ǹζк() */
	rtrim( english );

	if( ! ( strlen( japanese ) && strlen( english ) ) ) {
		/* ɤ餫ʸĹ */
		#ifdef DEBUG
			fprintf( stderr, "%s:exectmod_DoParseLine() Length of Strings is 0...\n", SourceFile );
		#endif

		free( japanese );
		free( english );

		return EPWING_ERROR;
	}

	fprintf( fp, "%s\n", japanese );
	fprintf( fp, "%s\n", english );

	free( japanese );
	free( english );

	return EPWING_SUCCESS;

}
